Index: /trunk/Cocoa/Pester/Source/PSAlarms.m
===================================================================
--- /trunk/Cocoa/Pester/Source/PSAlarms.m	(revision 52)
+++ /trunk/Cocoa/Pester/Source/PSAlarms.m	(revision 53)
@@ -9,9 +9,18 @@
 #import "PSAlarms.h"
 #import "PSAlarm.h"
+#import "NSDictionary-NJRExtensions.h"
+
+NSString * const PSAlarmImportException = @"PSAlarmImportException";
 
 NSString * const PSAlarmsDidChangeNotification = @"PSAlarmsDidChangeNotification";
 NSString * const PSAlarmsNextAlarmDidChangeNotification = @"PSAlarmsNextAlarmDidChangeNotification";
 
-static NSString * const PSPendingAlarms = @"Pester pending alarms"; // NSUserDefaults key
+// NSUserDefaults key
+static NSString * const PSPendingAlarms = @"Pester pending alarms"; // 1.0 Ð 1.1a3
+static NSString * const PSAllAlarms = @"Pester alarms"; // 1.1a4 Ð 
+
+// property list keys
+static NSString * const PLAlarmsPending = @"pending";
+static NSString * const PLAlarmsExpired = @"expired";
 
 static PSAlarms *PSAlarmsAllAlarms = nil;
@@ -28,5 +37,10 @@
 {
     if (PSAlarmsAllAlarms == nil) {
-        PSAlarmsAllAlarms = [[self alloc] init];
+        NSDictionary *plAlarms = [[NSUserDefaults standardUserDefaults] objectForKey: PSAllAlarms];
+        if (plAlarms == nil) {
+            PSAlarmsAllAlarms = [[self alloc] init];
+        } else {
+            PSAlarmsAllAlarms = [[self alloc] initWithPropertyList: plAlarms];
+        }
         [PSAlarmsAllAlarms _updateNextAlarm]; // only generate notifications after singleton established
     }
@@ -37,4 +51,46 @@
     NSAssert(PSAlarmsAllAlarms != nil, @"Attempt to use +[PSAlarms allAlarms] before setup complete");
     return PSAlarmsAllAlarms;
+}
+
+#pragma mark private
+
+- (void)_changed;
+{
+    NSMutableArray *alarmsData = [[NSMutableArray alloc] init];
+    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
+    [self _updateNextAlarm];
+    // NSLog(@"PSAlarms _changed:\n%@", alarms);
+    [defaults setObject: [self propertyListRepresentation] forKey: PSAllAlarms];
+    [defaults synchronize];
+    [alarmsData release];
+    [[NSNotificationCenter defaultCenter] postNotificationName: PSAlarmsDidChangeNotification object: self];
+}
+
+- (void)_alarmTimerExpired:(NSNotification *)notification;
+{
+    PSAlarm *alarm = [notification object];
+    NSLog(@"timer expired: %@ retainCount %d", alarm, [alarm retainCount]);
+    [expiredAlarms addObject: alarm];
+    NSLog(@"expired alarms: %@", [expiredAlarms description]);
+    [alarms removeObject: alarm];
+    [self _changed];
+}
+
+- (void)_alarmTimerSet:(NSNotification *)notification;
+{
+    PSAlarm *alarm = [notification object];
+    NSLog(@"timer set: %@ retainCount %d", alarm, [alarm retainCount]);
+    [alarms addObject: alarm];
+    [expiredAlarms removeObject: alarm];
+    [self _changed];
+}
+
+- (void)_alarmDied:(NSNotification *)notification;
+{
+    PSAlarm *alarm = [notification object];
+    NSLog(@"alarm died: %@ retainCount %d", alarm, [alarm retainCount]);
+    [alarms removeObject: alarm];
+    [expiredAlarms removeObject: alarm];
+    [self _changed];
 }
 
@@ -59,24 +115,19 @@
 }
 
+- (void)_setUpNotifications;
+{
+    [[NSNotificationCenter defaultCenter] addObserver: self selector: @selector(_alarmTimerSet:) name: PSAlarmTimerSetNotification object: nil];
+    [[NSNotificationCenter defaultCenter] addObserver: self selector: @selector(_alarmTimerExpired:) name: PSAlarmTimerExpiredNotification object: nil];
+    [[NSNotificationCenter defaultCenter] addObserver: self selector: @selector(_alarmDied:) name: PSAlarmDiedNotification object: nil];
+}
+
+#pragma mark initialize-release
+
 - (id)init;
 {
     if ( (self = [super init]) != nil) {
         alarms = [[NSMutableArray alloc] init];
-        NS_DURING
-            NSArray *alarmsData = [[NSUserDefaults standardUserDefaults] arrayForKey: PSPendingAlarms];
-            NSEnumerator *e = [alarmsData objectEnumerator];
-            NSData *alarmData;
-            PSAlarm *alarm;
-            while ( (alarmData = [e nextObject]) != nil) {
-                alarm = [NSUnarchiver unarchiveObjectWithData: alarmData];
-                if (alarm != nil)
-                    [alarms addObject: alarm];
-            }
-        NS_HANDLER
-            // XXX need better error handling here, don't stomp on data
-            NSLog(@"An error occurred while attempting to restore the alarm list: %@", localException);
-        NS_ENDHANDLER
-        [[NSNotificationCenter defaultCenter] addObserver: self selector: @selector(_alarmTimerSet:) name: PSAlarmTimerSetNotification object: nil];
-        [[NSNotificationCenter defaultCenter] addObserver: self selector: @selector(_alarmTimerExpired:) name: PSAlarmTimerExpiredNotification object: nil];
+        expiredAlarms = [[NSMutableSet alloc] init];
+        [self _setUpNotifications];
     }
     return self;
@@ -86,37 +137,14 @@
 {
     [alarms release];
+    [expiredAlarms release];
     [[NSNotificationCenter defaultCenter] removeObserver: self];
     [super dealloc];
 }
 
-- (void)_changed;
-{
-    NSMutableArray *alarmsData = [[NSMutableArray alloc] init];
-    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
-    NSEnumerator *e;
-    PSAlarm *alarm;
-    [self _updateNextAlarm];
-    // NSLog(@"PSAlarms _changed:\n%@", alarms);
-    // archive
-    e = [alarms objectEnumerator];
-    while ( (alarm = [e nextObject]) != nil) {
-        [alarmsData addObject: [NSArchiver archivedDataWithRootObject: alarm]];
-    }
-    [defaults setObject: alarmsData forKey: PSPendingAlarms];
-    [defaults synchronize];
-    [alarmsData release];
-    [[NSNotificationCenter defaultCenter] postNotificationName: PSAlarmsDidChangeNotification object: self];
-}
-
-- (void)_alarmTimerExpired:(NSNotification *)notification;
-{
-    [alarms removeObject: [notification object]];
-    [self _changed];
-}
-
-- (void)_alarmTimerSet:(NSNotification *)notification;
-{
-    [alarms addObject: [notification object]];
-    [self _changed];
+#pragma mark accessing
+
+- (NSArray *)alarms;
+{
+    return alarms;
 }
 
@@ -124,9 +152,4 @@
 {
     return nextAlarm;
-}
-
-- (NSArray *)alarms;
-{
-    return alarms;
 }
 
@@ -185,3 +208,95 @@
 }
 
+#pragma mark property list serialization (Pester 1.1)
+
+- (NSDictionary *)propertyListRepresentation;
+{
+    NSMutableArray *plPendingAlarms = [[NSMutableArray alloc] initWithCapacity: [alarms count]];
+    NSMutableArray *plExpiredAlarms = [[NSMutableArray alloc] initWithCapacity: [expiredAlarms count]];
+    NSDictionary *plAllAlarms, *plAlarm;
+    NSEnumerator *e;
+    PSAlarm *alarm;
+
+    e = [alarms objectEnumerator];
+    while ( (alarm = [e nextObject]) != nil) {
+        plAlarm = [alarm propertyListRepresentation];
+        if (plAlarm != nil)
+            [plPendingAlarms addObject: plAlarm];
+    }
+
+    e = [expiredAlarms objectEnumerator];
+    while ( (alarm = [e nextObject]) != nil) {
+        plAlarm = [alarm propertyListRepresentation];
+        if (plAlarm != nil)
+            [plExpiredAlarms addObject: plAlarm];
+    }
+    
+    plAllAlarms = [NSDictionary dictionaryWithObjectsAndKeys:
+        plPendingAlarms, PLAlarmsPending, plExpiredAlarms, PLAlarmsExpired, nil];
+    [plPendingAlarms release];
+    [plExpiredAlarms release];
+    
+    return plAllAlarms;
+}
+
+- (id)initWithPropertyList:(NSDictionary *)dict;
+{
+    if ( (self = [super init]) != nil) {
+        NSArray *plPendingAlarms = [dict objectForRequiredKey: PLAlarmsPending];
+        NSArray *plExpiredAlarms = [dict objectForRequiredKey: PLAlarmsExpired];
+        NSEnumerator *e;
+        NSDictionary *plAlarm;
+        PSAlarm *alarm;
+
+        alarms = [[NSMutableArray alloc] initWithCapacity: [plPendingAlarms count]];
+        e = [plPendingAlarms objectEnumerator];
+        while ( (plAlarm = [e nextObject]) != nil) {
+            [alarms addObject: [[PSAlarm alloc] initWithPropertyList: plAlarm]];
+        }
+
+        e = [plExpiredAlarms objectEnumerator];
+        while ( (plAlarm = [e nextObject]) != nil) {
+            // expired alarms may be just that, or they may have outstanding repeats - if the latter, PSAlarm will reschedule the alarm.
+            if ( (alarm = [[PSAlarm alloc] initWithPropertyList: plAlarm]) != nil)
+                [alarms addObject: alarm];
+        }
+        expiredAlarms = [[NSMutableSet alloc] init];
+        
+        [self _setUpNotifications];
+    }
+    return self;
+}
+
+#pragma mark archiving (Pester 1.0)
+
+- (unsigned)countOfVersion1Alarms;
+{
+    return [[[NSUserDefaults standardUserDefaults] objectForKey: PSPendingAlarms] count];
+}
+
+- (void)discardVersion1Alarms;
+{
+    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
+    [defaults removeObjectForKey: PSPendingAlarms];
+    [defaults synchronize];
+}
+
+- (void)importVersion1Alarms;
+{
+    NSArray *alarmsData = [[NSUserDefaults standardUserDefaults] arrayForKey: PSPendingAlarms];
+    NSEnumerator *e = [alarmsData objectEnumerator];
+    NSData *alarmData;
+    PSAlarm *alarm;
+    while ( (alarmData = [e nextObject]) != nil) {
+        NS_DURING
+            alarm = [NSUnarchiver unarchiveObjectWithData: alarmData];
+        NS_HANDLER
+            alarm = nil;
+            // XXX
+        NS_ENDHANDLER
+        if (alarm != nil)
+            [alarms addObject: alarm];
+    }
+}
+
 @end
Index: /trunk/Cocoa/Pester/Source/PSAlarmsController.m
===================================================================
--- /trunk/Cocoa/Pester/Source/PSAlarmsController.m	(revision 52)
+++ /trunk/Cocoa/Pester/Source/PSAlarmsController.m	(revision 53)
@@ -9,4 +9,5 @@
 #import "PSAlarmsController.h"
 #import "PSAlarm.h"
+#import "PSAlerts.h"
 #import "NSTableView-NJRExtensions.h"
 #import "NJRTableView.h"
@@ -82,4 +83,11 @@
 }
 
+- (NSString *)tableView:(NSTableView *)aTableView toolTipForTableColumn:(NSTableColumn *)aTableColumn row:(int)rowIndex;
+{
+    PSAlarm *alarm = [reorderedAlarms objectAtIndex: rowIndex];
+
+    return [[alarm prettyDescription] string];
+}
+
 @end
 
Index: /trunk/Cocoa/Pester/Source/PSAlert.h
===================================================================
--- /trunk/Cocoa/Pester/Source/PSAlert.h	(revision 52)
+++ /trunk/Cocoa/Pester/Source/PSAlert.h	(revision 53)
@@ -9,14 +9,24 @@
 #import <Foundation/Foundation.h>
 #import "PSAlarm.h"
+#import "PSPropertyListSerialization.h"
+#import "NSString-NJRExtensions.h"
 
-@interface PSAlert : NSObject {
+extern NSString * const PSAlertCreationException;
 
+extern NSString * const PSAlarmAlertCompletedNotification; // userInfo key: "alert" -> PSAlert
+
+@interface PSAlert : NSObject <PSPropertyListSerialization> {
+    
 }
-
-// XXX need archiving support
 
 // subclasses should implement these methods
 + (PSAlert *)alert;
 - (void)triggerForAlarm:(PSAlarm *)alarm;
+- (BOOL)requiresPesterFrontmost;
+
+- (NSAttributedString *)actionDescription;
+
+// after alert completes, invoke method of superclass
+- (void)completedForAlarm:(PSAlarm *)alarm;
 
 @end
Index: /trunk/Cocoa/Pester/Source/PSAlert.m
===================================================================
--- /trunk/Cocoa/Pester/Source/PSAlert.m	(revision 52)
+++ /trunk/Cocoa/Pester/Source/PSAlert.m	(revision 53)
@@ -8,5 +8,12 @@
 
 #import "PSAlert.h"
+#import "NSDictionary-NJRExtensions.h"
 
+NSString * const PSAlertCreationException = @"PSAlertCreationException";
+
+NSString * const PSAlarmAlertCompletedNotification = @"PSAlarmAlertCompletedNotification";
+
+// property list keys
+static NSString * const PLAlertClass = @"class"; // NSString
 
 @implementation PSAlert
@@ -23,3 +30,44 @@
 }
 
+- (BOOL)requiresPesterFrontmost;
+{
+    return NO;
+}
+
+- (void)completedForAlarm:(PSAlarm *)alarm;
+{
+    [[NSNotificationCenter defaultCenter] postNotificationName: PSAlarmAlertCompletedNotification object: alarm userInfo: [NSDictionary dictionaryWithObject: self forKey: @"alert"]];
+}
+
+- (NSAttributedString *)actionDescription;
+{
+    NSAssert(NO, @"Class is abstract");
+    return nil;
+}
+
+#pragma mark property list serialization (Pester 1.1)
+
+- (NSDictionary *)propertyListRepresentation;
+{
+    return [NSDictionary dictionaryWithObject: NSStringFromClass([self class]) forKey: PLAlertClass];
+}
+
+- (id)initWithPropertyList:(NSDictionary *)dict;
+{
+    if ( (self = [self init]) != nil) {
+        IMP myImp = [self methodForSelector: _cmd];
+        NSString *clsString = [dict objectForRequiredKey: PLAlertClass];
+        Class cls = NSClassFromString(clsString);
+        NSAssert1(cls != nil, @"Alert class %@ is not available", clsString);
+        [super release];
+        self = [cls alloc];
+        if (self != nil) {
+            IMP subImp = [self methodForSelector: @selector(initWithPropertyList:)];
+            NSAssert1(subImp != myImp, @"No implementation of initWithPropertyList: for alert class %@", clsString);
+            self = [self initWithPropertyList: dict];
+        }
+    }
+    return self;
+}
+
 @end
Index: /trunk/Cocoa/Pester/Source/PSAlerts.h
===================================================================
--- /trunk/Cocoa/Pester/Source/PSAlerts.h	(revision 53)
+++ /trunk/Cocoa/Pester/Source/PSAlerts.h	(revision 53)
@@ -0,0 +1,34 @@
+//
+//  PSAlerts.h
+//  Pester
+//
+//  Created by Nicholas Riley on Sat Dec 21 2002.
+//  Copyright (c) 2002 Nicholas Riley. All rights reserved.
+//
+
+#import <AppKit/AppKit.h>
+#import "PSPropertyListSerialization.h"
+
+@class PSAlert, PSAlarm;
+
+@interface PSAlerts : NSObject <PSPropertyListSerialization>
+{
+    NSMutableArray *alerts;
+    BOOL requirePesterFrontmost;
+}
+
+- (id)init;
+- (id)initWithPesterVersion1Alerts;
+
+- (void)addAlert:(PSAlert *)alert;
+- (void)removeAlerts;
+
+- (NSArray *)allAlerts;
+- (NSEnumerator *)alertEnumerator;
+- (BOOL)requirePesterFrontmost; // do any alerts require Pester be in front?
+
+- (void)triggerForAlarm:(PSAlarm *)alarm;
+
+- (NSAttributedString *)prettyList;
+
+@end
Index: /trunk/Cocoa/Pester/Source/PSAlerts.m
===================================================================
--- /trunk/Cocoa/Pester/Source/PSAlerts.m	(revision 53)
+++ /trunk/Cocoa/Pester/Source/PSAlerts.m	(revision 53)
@@ -0,0 +1,134 @@
+//
+//  PSAlerts.m
+//  Pester
+//
+//  Created by Nicholas Riley on Sat Dec 21 2002.
+//  Copyright (c) 2002 Nicholas Riley. All rights reserved.
+//
+
+#import "PSAlerts.h"
+#import "PSAlert.h"
+#import "PSDockBounceAlert.h"
+#import "PSNotifierAlert.h"
+#import "PSBeepAlert.h"
+
+// property list keys
+static NSString * const PLAlerts = @"alerts"; // NSString
+
+@implementation PSAlerts
+
+#pragma mark initialize-release
+
+- (id)init;
+{
+    if ( (self = [super init]) != nil) {
+        alerts = [[NSMutableArray alloc] initWithCapacity: 4];
+    }
+    return self;
+}
+
+- (id)initWithPesterVersion1Alerts;
+{
+    if ( (self = [self init]) != nil) {
+        [self addAlert: [PSDockBounceAlert alert]];
+        [self addAlert: [PSNotifierAlert alert]];
+        [self addAlert: [PSBeepAlert alertWithRepetitions: 1]];
+    }
+    return self;
+}
+
+- (void)dealloc;
+{
+    [alerts release]; alerts = nil;
+}
+
+#pragma mark accessing
+
+- (void)addAlert:(PSAlert *)alert;
+{
+    [alerts addObject: alert];
+    if ([alert requiresPesterFrontmost])
+        requirePesterFrontmost = YES;
+}
+
+- (void)removeAlerts;
+{
+    [alerts removeAllObjects];
+    requirePesterFrontmost = NO;
+}
+
+- (NSEnumerator *)alertEnumerator;
+{
+    return [alerts objectEnumerator];
+}
+
+- (NSArray *)allAlerts;
+{
+    return [[alerts copy] autorelease];
+}
+
+- (BOOL)requirePesterFrontmost;
+{
+    return requirePesterFrontmost;
+}
+
+#pragma mark actions
+
+- (void)triggerForAlarm:(PSAlarm *)alarm;
+{
+    [alerts makeObjectsPerformSelector: @selector(triggerForAlarm:) withObject: alarm];
+}
+
+#pragma mark printing
+
+- (NSAttributedString *)prettyList;
+{
+    NSMutableAttributedString *string = [[NSMutableAttributedString alloc] init];
+    NSEnumerator *e = [self alertEnumerator];
+    PSAlert *alert;
+    unsigned int length;
+    while ( (alert = [e nextObject]) != nil) {
+        [string appendAttributedString: [@"¥ " small]];
+        [string appendAttributedString: [alert actionDescription]];
+        [string appendAttributedString: [@"\n" small]];
+    }
+    if ( (length = [string length]) == 0) {
+        [string release];
+        return nil;
+    } else {
+        NSMutableParagraphStyle *paraStyle = [[NSParagraphStyle defaultParagraphStyle] mutableCopy];
+        [string deleteCharactersInRange: NSMakeRange(length - 1, 1)]; // remove trailing newline
+        [paraStyle setHeadIndent: [[string attribute: NSFontAttributeName atIndex: 0 effectiveRange: NULL] widthOfString: @"¥ "]];
+        [string addAttribute: NSParagraphStyleAttributeName value: paraStyle range: NSMakeRange(0, length - 1)];
+        [paraStyle release]; paraStyle = nil;
+        return [string autorelease];
+    }
+}
+
+#pragma mark property list serialization (Pester 1.1)
+
+- (NSDictionary *)propertyListRepresentation;
+{
+    NSMutableArray *plAlerts = [[NSMutableArray alloc] initWithCapacity: [alerts count]];
+    NSEnumerator *e = [self alertEnumerator];
+    PSAlert *alert;
+    while ( (alert = [e nextObject]) != nil) {
+        [plAlerts addObject: [alert propertyListRepresentation]];
+    }
+    return [NSDictionary dictionaryWithObject: plAlerts forKey: PLAlerts];
+}
+
+- (id)initWithPropertyList:(NSDictionary *)dict;
+{
+    if ( (self = [self init]) != nil) {
+        NSArray *plAlerts = [dict objectForKey: PLAlerts];
+        NSEnumerator *e = [plAlerts objectEnumerator];
+        NSDictionary *alertDict;
+        while ( (alertDict = [e nextObject]) != nil) {
+            [self addAlert: [[PSAlert alloc] initWithPropertyList: alertDict]];
+        }
+    }
+    return self;
+}
+
+@end
Index: /trunk/Cocoa/Pester/Source/PSApplication.m
===================================================================
--- /trunk/Cocoa/Pester/Source/PSApplication.m	(revision 52)
+++ /trunk/Cocoa/Pester/Source/PSApplication.m	(revision 53)
@@ -21,4 +21,5 @@
     [[NSNotificationCenter defaultCenter] addObserver: [PSAlarmAlertController class] selector: @selector(controllerWithTimerExpiredNotification:) name: PSAlarmTimerExpiredNotification object: nil];
     [[NSNotificationCenter defaultCenter] addObserver: self selector: @selector(nextAlarmDidChange:) name: PSAlarmsNextAlarmDidChangeNotification object: nil];
+    // XXX exception handling
     [PSAlarms setUp];
     [self setDelegate: self];
@@ -71,9 +72,10 @@
 {
     PSAlarm *alarm = [timer userInfo];
-    NSTimeInterval alarmInterval;
+    NSTimeInterval timeRemaining;
     NSString *tileString;
     if (timer == nil) alarm = [[PSAlarms allAlarms] nextAlarm];
     if (alarm == nil) return;
     tileString = [alarm timeRemainingString];
+    timeRemaining = [alarm timeRemaining]; // want to err on the side of timeRemaining being smaller, otherwise ÇexpiredÈ can appear
     {
         NSMutableDictionary *atts = [NSMutableDictionary dictionary];
@@ -117,8 +119,7 @@
         [tile release];
     }
-    alarmInterval = [alarm interval];
-    // NSLog(@"_updateDockTile > time remaining %@ (%.0lf), last time interval %.0lf", tileString, alarmInterval, dockUpdateInterval);
-    if (alarmInterval > 61) {
-        NSTimeInterval nextUpdate = ((unsigned long long)alarmInterval) % 60;
+    // NSLog(@"_updateDockTile > time remaining %@ (%.6lf), last time interval %.6lf", tileString, timeRemaining, dockUpdateInterval);
+    if (timeRemaining > 61) {
+        NSTimeInterval nextUpdate = ((unsigned long long)timeRemaining) % 60;
         if (nextUpdate <= 1) nextUpdate = 60;
         [self _resetUpdateTimer];
@@ -126,8 +127,8 @@
         // NSLog(@"_updateDockTile > set timer for %.0lf seconds", nextUpdate);
     } else if (timer == nil || dockUpdateInterval > 1) {
-        [self _resetUpdateTimer];
+        [self _resetUpdateTimer]; 
         [self _setUpdateTimerForInterval: 1 alarm: alarm repeats: YES];
         // NSLog(@"_updateDockTile > set timer for 1 second");
-    } else if (alarmInterval < 2) {
+    } else if (timeRemaining <= 1) {
         [self _resetUpdateTimer];
     }
@@ -182,4 +183,32 @@
 @implementation PSApplication (NSApplicationNotifications)
 
+- (void)applicationDidFinishLaunching:(NSNotification *)notification;
+{
+    // XXX import panel will not be frontmost window if you switch to another app while Pester is launching; Mac OS X bug?
+    PSAlarms *allAlarms = [PSAlarms allAlarms];
+    unsigned version1AlarmCount = [allAlarms countOfVersion1Alarms];
+    if (version1AlarmCount > 0) {
+        int answer = NSRunAlertPanel(@"Import alarms from older Pester version?", @"Pester found %u alarm%@ created with an older version. These alarms must be converted for use with this version of Pester, and will be unavailable in previous versions after conversion. New alarms created with this version of Pester will not appear in Pester version 1.1a3 or earlier.",
+                                     @"Import", @"Discard", @"DonÕt Import",
+                                     version1AlarmCount, version1AlarmCount == 1 ? @"" : @"s");
+        switch (answer) {
+            case NSAlertDefaultReturn:
+                NS_DURING
+                    [allAlarms importVersion1Alarms];
+                NS_HANDLER
+                    NSRunAlertPanel(@"Error occurred importing alarms", @"Pester was unable to convert some alarms created with an older version. Those alarms which could be read have been converted. The previous-format alarms have been retained; try using an older version of Pester to read them.\n\n%@", nil, nil, nil, [localException reason]);
+                    NS_VOIDRETURN;
+                NS_ENDHANDLER
+            case NSAlertAlternateReturn:
+                NSLog(@"discard");
+                // [allAlarms discardVersion1Alarms];
+                break;
+            case NSAlertOtherReturn:
+                NSLog(@"donÕt import");
+                break;
+        }
+    }
+}
+
 - (void)applicationWillTerminate:(NSNotification *)notification;
 {
Index: /trunk/Cocoa/Pester/Source/PSBeepAlert.h
===================================================================
--- /trunk/Cocoa/Pester/Source/PSBeepAlert.h	(revision 52)
+++ /trunk/Cocoa/Pester/Source/PSBeepAlert.h	(revision 53)
@@ -9,8 +9,8 @@
 #import "PSAlert.h"
 
-
 @interface PSBeepAlert : PSAlert {
+    PSAlarm *alarm;
     unsigned short repetitions;
-    unsigned short repetitionsRemaining;    
+    unsigned short repetitionsRemaining;
 }
 
@@ -18,3 +18,5 @@
 - (id)initWithRepetitions:(unsigned short)numReps;
 
+- (unsigned short)repetitions;
+
 @end
Index: /trunk/Cocoa/Pester/Source/PSBeepAlert.m
===================================================================
--- /trunk/Cocoa/Pester/Source/PSBeepAlert.m	(revision 52)
+++ /trunk/Cocoa/Pester/Source/PSBeepAlert.m	(revision 53)
@@ -10,4 +10,8 @@
 #import "PSBeepAlert.h"
 #import "PSAlarmAlertController.h"
+#import "NSDictionary-NJRExtensions.h"
+
+// property list keys
+static NSString * const PLAlertRepetitions = @"times"; // NSNumber
 
 @implementation PSBeepAlert
@@ -32,4 +36,9 @@
 }
 
+- (unsigned short)repetitions;
+{
+    return repetitions;
+}
+
 - (void)beep;
 {
@@ -37,4 +46,5 @@
     repetitionsRemaining--;
     if (repetitionsRemaining == 0) {
+        [self completedForAlarm: alarm];
         [self release];
         return;
@@ -48,6 +58,7 @@
 }
 
-- (void)triggerForAlarm:(PSAlarm *)alarm;
+- (void)triggerForAlarm:(PSAlarm *)anAlarm;
 {
+    alarm = anAlarm;
     repetitionsRemaining = repetitions;
     [self retain];
@@ -56,3 +67,23 @@
 }
 
+- (NSAttributedString *)actionDescription;
+{
+    return [[@"Play the system alert sound" stringByAppendingString:
+                                            repetitions == 1 ? @"" : [NSString stringWithFormat: @" %hu times", repetitions]] small];
+}
+
+#pragma mark property list serialization (Pester 1.1)
+
+- (NSDictionary *)propertyListRepresentation;
+{
+    NSMutableDictionary *plAlert = [[super propertyListRepresentation] mutableCopy];
+    [plAlert setObject: [NSNumber numberWithUnsignedShort: repetitions] forKey: PLAlertRepetitions];
+    return [plAlert autorelease];
+}
+
+- (id)initWithPropertyList:(NSDictionary *)dict;
+{
+    return [self initWithRepetitions: [[dict objectForRequiredKey: PLAlertRepetitions] unsignedShortValue]];
+}
+
 @end
Index: /trunk/Cocoa/Pester/Source/PSDockBounceAlert.m
===================================================================
--- /trunk/Cocoa/Pester/Source/PSDockBounceAlert.m	(revision 52)
+++ /trunk/Cocoa/Pester/Source/PSDockBounceAlert.m	(revision 53)
@@ -30,5 +30,19 @@
     [NSApp requestUserAttention: NSInformationalRequest];
     [[self class] performSelector: @selector(stopBouncing) withObject: nil afterDelay: 1 inModes: [NSArray arrayWithObject: NSDefaultRunLoopMode]];
+    [self completedForAlarm: alarm];
 }
 
+- (NSAttributedString *)actionDescription;
+{
+    return [@"Bounce dock icon" small];
+}
+
+#pragma mark property list serialization (Pester 1.1)
+
+- (id)initWithPropertyList:(NSDictionary *)dict;
+{
+    [self release];
+    return [[PSDockBounceAlert alert] retain];
+}
+        
 @end
Index: /trunk/Cocoa/Pester/Source/PSError.h
===================================================================
--- /trunk/Cocoa/Pester/Source/PSError.h	(revision 53)
+++ /trunk/Cocoa/Pester/Source/PSError.h	(revision 53)
@@ -0,0 +1,24 @@
+//
+//  PSError.h
+//  Pester
+//
+//  Created by Nicholas Riley on Sun Dec 29 2002.
+//  Copyright (c) 2002 Nicholas Riley. All rights reserved.
+//
+
+#import <Foundation/Foundation.h>
+
+
+@interface PSError : NSObject {
+    NSCountedSet *reasons;
+    NSString *operation;
+    unsigned count;
+}
+
+// create an error object
++ (PSError *)error;
+
+// raise exception, invalidates error object
+- (void)raiseIfNeededForOperation:(NSString *)anOperation count:(unsigned)aCount;
+
+@end
Index: /trunk/Cocoa/Pester/Source/PSError.m
===================================================================
--- /trunk/Cocoa/Pester/Source/PSError.m	(revision 53)
+++ /trunk/Cocoa/Pester/Source/PSError.m	(revision 53)
@@ -0,0 +1,60 @@
+//
+//  PSError.m
+//  Pester
+//
+//  Created by Nicholas Riley on Sun Dec 29 2002.
+//  Copyright (c) 2002 Nicholas Riley. All rights reserved.
+//
+
+#import "PSError.h"
+
+static NSString * const PSErrorException = @"PSErrorException";
+
+@implementation PSError
+
++ (PSError *)error;
+{
+    return [[self alloc] init];
+}
+
+- (void)dealloc;
+{
+    [reasons release]; reasons = nil;
+    [operation release]; operation = nil;
+    [super dealloc];
+}
+
+- (NSCountedSet *)reasons;
+{
+    if (reasons == nil)
+        reasons = [[NSCountedSet alloc] initWithCapacity: 2];
+    return reasons;
+}
+
+- (void)addException:(NSException *)exception;
+{
+
+}
+
+- (void)raiseIfNeededForOperation:(NSString *)anOperation count:(unsigned)aCount;
+{
+    if (reasons != nil && [reasons count] > 0) {
+        // NSMutableString *
+        [self autorelease];
+        [NSException raise: PSErrorException
+                    format: @"Pester encountered errors while %@ %@."];
+    } else {
+        [self release];
+    }
+}
+
+@end
+
+/* Use cases:
+   - PSAlerts => can't restore one or more alerts, keep the rest
+   - 
+
+   Need to add error to initWithPropertyList: protocol, otherwise we can't get back partially-formed objects.
+   - (id)initWithPropertyList:(NSDictionary *)dict error:(PSException **)exception;
+
+ */
Index: /trunk/Cocoa/Pester/Source/PSMovieAlert.h
===================================================================
--- /trunk/Cocoa/Pester/Source/PSMovieAlert.h	(revision 52)
+++ /trunk/Cocoa/Pester/Source/PSMovieAlert.h	(revision 53)
@@ -9,6 +9,6 @@
 #import <AppKit/AppKit.h>
 #import "PSAlert.h"
-#import "BDAlias.h"
 
+@class BDAlias;
 
 @interface PSMovieAlert : PSAlert {
@@ -22,8 +22,9 @@
 + (PSMovieAlert *)alertWithMovieFileAlias:(BDAlias *)anAlias repetitions:(unsigned short)numReps;
 
-- (id)initWithAlias:(BDAlias *)anAlias repetitions:(unsigned int) numReps;
+- (id)initWithMovieFileAlias:(BDAlias *)anAlias repetitions:(unsigned int) numReps;
 
 - (BOOL)hasVideo;
 - (NSMovie *)movie;
+- (BDAlias *)movieFileAlias;
 - (unsigned short)repetitions;
 
Index: /trunk/Cocoa/Pester/Source/PSMovieAlert.m
===================================================================
--- /trunk/Cocoa/Pester/Source/PSMovieAlert.m	(revision 52)
+++ /trunk/Cocoa/Pester/Source/PSMovieAlert.m	(revision 53)
@@ -10,5 +10,11 @@
 #import "PSMovieAlert.h"
 #import "PSMovieAlertController.h"
+#import "NSDictionary-NJRExtensions.h"
 #import "NSMovie-NJRExtensions.h"
+#import "BDAlias.h"
+
+// property list keys
+static NSString * const PLAlertRepetitions = @"times"; // NSString
+static NSString * const PLAlertAlias = @"alias"; // NSData
 
 @implementation PSMovieAlert
@@ -16,13 +22,18 @@
 + (PSMovieAlert *)alertWithMovieFileAlias:(BDAlias *)anAlias repetitions:(unsigned short)numReps;
 {
-    return [[[self alloc] initWithAlias: anAlias repetitions: numReps] autorelease];
+    return [[[self alloc] initWithMovieFileAlias: anAlias repetitions: numReps] autorelease];
 }
 
-- (id)initWithAlias:(BDAlias *)anAlias repetitions:(unsigned int) numReps;
+- (id)initWithMovieFileAlias:(BDAlias *)anAlias repetitions:(unsigned int) numReps;
 {
     if ( (self = [super init]) != nil) {
+        NSString *path = [anAlias fullPath];
+        if (path == nil) {
+            [self release];
+            [NSException raise: PSAlertCreationException format: @"CanÕt locate media to play as alert."];
+        }
         alias = [anAlias retain];
         repetitions = numReps;
-        movie = [[NSMovie alloc] initWithURL: [NSURL fileURLWithPath: [anAlias fullPath]] byReference: YES];
+        movie = [[NSMovie alloc] initWithURL: [NSURL fileURLWithPath: path] byReference: YES];
         if (movie == nil) {
             [self release];
@@ -46,7 +57,17 @@
 }
 
+- (BOOL)requiresPesterFrontmost;
+{
+    return hasVideo;
+}
+
 - (NSMovie *)movie;
 {
     return movie;
+}
+
+- (BDAlias *)movieFileAlias;
+{
+    return alias;
 }
 
@@ -73,3 +94,33 @@
 }
 
+- (NSAttributedString *)actionDescription;
+{
+    BOOL isStatic = [movie isStatic];
+    NSMutableAttributedString *string = [[(isStatic ? @"Show " : @"Play ") small] mutableCopy];
+    NSString *kindString = nil, *name = [alias displayNameWithKindString: &kindString];
+    if (name == nil) name = @"ÇcanÕt locate media fileÈ";
+    else [string appendAttributedString: [[NSString stringWithFormat: @"%@ ", kindString] small]];
+    [string appendAttributedString: [name underlined]];
+    if (repetitions > 1 && !isStatic) {
+        [string appendAttributedString: [[NSString stringWithFormat: @" %hu times", repetitions] small]];
+    }
+    return [string autorelease];
+}
+
+#pragma mark property list serialization (Pester 1.1)
+
+- (NSDictionary *)propertyListRepresentation;
+{
+    NSMutableDictionary *plAlert = [[super propertyListRepresentation] mutableCopy];
+    [plAlert setObject: [NSNumber numberWithUnsignedShort: repetitions] forKey: PLAlertRepetitions];
+    [plAlert setObject: [alias aliasData] forKey: PLAlertAlias];
+    return [plAlert autorelease];
+}
+
+- (id)initWithPropertyList:(NSDictionary *)dict;
+{
+    return [self initWithMovieFileAlias: [BDAlias aliasWithData: [dict objectForRequiredKey: PLAlertAlias]]
+                            repetitions: [[dict objectForRequiredKey: PLAlertRepetitions] unsignedShortValue]];
+}
+
 @end
